# vue-shufflejs-plugin

[![vue2](https://img.shields.io/badge/vue-2.x-brightgreen.svg)](https://vuejs.org/)

A [Vue.js](https://vuejs.org) plugin for [Shuffle.js](https://vestride.github.io/Shuffle/) library.  
**Note**: This project is still under development!

The plugin use and require the following packages:

* [Bootstrap 3](http://getbootstrap.com) - Grid system
* [vue-multiselect](https://vue-multiselect.js.org) - Probably the most complete selecting solution for Vue.js 2.0, without jQuery. ([Github](https://github.com/shentao/vue-multiselect))
* [imagesLoaded](http://imagesloaded.desandro.com) - Detect when images have been loaded. ([Github](https://github.com/desandro/imagesloaded))

## Documentation

- [Shuffle.js Docs](https://vestride.github.io/Shuffle/)

## Installation

The preferred way to install this extension is through [yarn](https://yarnpkg.com) or [npm](https://www.npmjs.com).

Either run 

```bash
yarn add https://git.hrzg.de/dmstr/vue-shufflejs-plugin.git#0.2.8
```
or via npm 

```bash
npm install https://git.hrzg.de/dmstr/vue-shufflejs-plugin.git#0.2.8 --save
```
## Usage

The following types are supported: 

- [Basic masonry layout](https://vestride.github.io/Shuffle/basic) without any extra options 
- Grid with [filter, search and / or sort options](https://vestride.github.io/Shuffle/)
- ...

The following example renders the [Shuffle.js](https://vestride.github.io/Shuffle/) plugin with Filter, Search and Sort `options`.  
Please check the [Shuffle.js](https://vestride.github.io/Shuffle/) documentation for available `options` supported by the plugin.

#### Bundler (Webpack, etc.)

```js
import Vue from 'vue'
import VueShuffle from 'vue-shufflejs-plugin'
// You need a specific loader for CSS files like https://github.com/webpack/css-loader
import 'vue-shufflejs-plugin/dist/vue-shufflejs-plugin.css'

Vue.use(VueShuffle)
```

###### Bootstrap icon font issue:

Add

```bash
yarn add url-loader --dev
```
or via npm 

```bash
npm install url-loader --save-dev
```
Updated module rules section in webpack config and add:

```js
{
  test: /\.(woff2?|eot|ttf|otf|svg)(\?.*)?$/,
  loader: 'url-loader'
}
```

#### Browser

```html
<!-- Include after Vue -->
<!-- Local files -->
<link rel="stylesheet" href="vue-shufflejs-plugin/dist/vue-shufflejs-plugin.css"></link>
<script src="vue-shufflejs-plugin/dist/vue-shufflejs-plugin.js"></script>
```

#### Use Component

WIP!

````js
settings: {
  baseUrl: 'http://manufacturer-blueprint.workbench.oneba.se',
  imageApiPath: '/filefly/api?action=stream&path=',
  imgBaseUrl: 'http://img.workbench.oneba.se',
  imgHostPrefix: 'http://manufacturer-blueprint.workbench.oneba.se/img/stream',
  imgHostSuffix: ',p1',
  detailPath: false, // or '/de/frontend/products/detail?productId='
  endpoints: {
    data: '/de/api/product-data',
    option: '/de/api/product-option',
    filter: '/de/api/product-filter'
  },
  enabledSearch: true,
  enabledSort: true
},
products: {
  data: null,
  option: null,
  filter: null
}
````

```html
<vue-shuffle :settings="settings" :products="products"></vue-shuffle>
```

## Tests

WIP!

## Devlopment

WIP!

```bash
# serve with hot reload at localhost:8080
yarn run dev

# distribution build with minification
yarn run build

# build the documentation into docs
yarn run docs

# run unit tests
yarn run test

# run unit tests watch
yarn run unit-watch
```

For detailed explanation on how things work, checkout the [guide](http://vuejs-templates.github.io/webpack/) and [docs for vue-loader](http://vuejs.github.io/vue-loader).

### Further Information

[Shuffle.js](https://vestride.github.io/Shuffle/) has lots of configuration options, please check the [Shuffle.js](https://vestride.github.io/Shuffle/) library website.

## Credits

* [Glen Cheney](https://github.com/Vestride) - [Shuffle.js](https://vestride.github.io/Shuffle/)
* [Damian Dulisz](https://github.com/shentao/vue-multiselect) -  [vue-multiselect](https://github.com/shentao/vue-multiselect)
* [David DeSandro](https://github.com/desandro) - [desandro/imagesloaded](http://imagesloaded.desandro.com)


## License

The MIT License (MIT). Please see [License File](./LICENSE.md) for more information.
