/**
 * Sanitize filter
 * @param value
 * @returns {string}
 */
export const sanitize = (value) => {
  let slug = ''

  // Change to lower case
  const toLowerCase = value.toLowerCase()

  // Letter "e"
  slug = toLowerCase.replace(/e|é|è|ẽ|ẻ|ẹ|ê|ế|ề|ễ|ể|ệ/gi, 'e')

  // Letter "a"
  slug = slug.replace(/a|á|à|ã|ả|ạ|ă|ắ|ằ|ẵ|ẳ|ặ|â|ấ|ầ|ẫ|ẩ|ậ/gi, 'a')

  // Letter "o"
  slug = slug.replace(/o|ó|ò|õ|ỏ|ọ|ô|ố|ồ|ỗ|ổ|ộ|ơ|ớ|ờ|ỡ|ở|ợ/gi, 'o')

  // Letter "đ"
  slug = slug.replace(/u|ú|ù|ũ|ủ|ụ|ư|ứ|ừ|ữ|ử|ự/gi, 'u')

  // Letter "d"
  slug = slug.replace(/đ/gi, 'd')

  // Letter "ö"
  slug = slug.replace(/ä/gi, 'ae')

  // Letter "ö"
  slug = slug.replace(/ö/gi, 'oe')

  // Letter "ö"
  slug = slug.replace(/ü/gi, 'ue')

  // Letter "ß"
  slug = slug.replace(/ß/gi, 'ss')

  // Trim the last whitespace
  slug = slug.replace(/\s*$/g, '')

  // Change whitespace to "-"
  slug = slug.replace(/\s+/g, '-')

  return slug
}
